﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using HtmlAgilityPack;
using VehicleStatsBL;
using VehicleStatsBL.Impl;
using VehicleStatsBL.Interface;
using log4net;

namespace VehicleStatsApp
{
    class Program
    {
        private const string outputPath = @"c:\temp";
        static void Main(string[] args)
        {
            log4net.Config.XmlConfigurator.Configure();
            ILog log = LogManager.GetLogger(typeof(Program));
                        
            log.Debug("Starting...");
            

            IResultsStreamer streamer = new BinaryResultsStreamer(log);
            IExtractionResults results = streamer.Read(@"C:\temp\bmw[3-series] 2000_2013 (20131111).dat");

            var extractionArgs = ExtractionArguments.Create("bmw", "3-series", 2000, 2013);
            

            var extractionResults = new ExtractionResults(new StatisticsFactory());

           
 
            var scraper = new AutoTraderZaPageScraper(log);

            ExtractionEngine engine = new ExtractionEngine(new HtmlWebWrapper(log), log, scraper);
            engine.Extract(extractionArgs, extractionResults);
            
            streamer.Write(extractionResults, string.Format("{0}\\{1}[{2}] {3}_{4} ({5}).dat", outputPath, 
                extractionArgs.Make,
                extractionArgs.Model,
                extractionArgs.From,
                extractionArgs.To,
                DateTime.Now.ToString("yyyyMMdd")));
        }
    }
}