﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using VehicleStatsBL.Interface;

namespace VehicleStatsBL.Impl
{
    public class ExtractionArguments : IExtractionArguments
    {
        public const int MaxDuration = 15;

        private ExtractionArguments()
        {

        }

        public string Make { get; private set; }

        public string Model { get; private set; }

        public int From { get; private set; }

        public int To { get; private set; }

        public static ExtractionArguments Create(string make, string model, int from, int to)
        {
            if (make != null && make.Trim() == string.Empty) 
                throw new ArgumentException("Make cannot be null or an empty string", "make");

            if (model != null && model.Trim() == string.Empty) 
                throw new ArgumentException("Make cannot be null or an empty string", "model");

            ExtractionArguments args = new ExtractionArguments() { Make = make, Model = model, From = from, To = to };
            args.CheckYearRange();
            return args;
        }

        private void CheckYearRange()
        {
            if (To - From > MaxDuration)
                throw new ArgumentException("Year duration should be less than " + MaxDuration.ToString(), "from or to");
        }
    }
}
