﻿using HtmlAgilityPack;
using log4net;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using VehicleStatsBL.Interface;

namespace VehicleStatsBL.Impl
{
    public class HtmlWebWrapper : IHtmlWebWrapper
    {

        private const int maxRetries = 5;

        private HtmlWeb _htmlWeb;
        private ILog _log;
        
        public HtmlWebWrapper(ILog log)
        {
            _htmlWeb = new HtmlWeb();
            _log = log;
        }
        public HtmlDocument Load(string url)
        {
            int retryCount = 0;
            bool loaded = false;
            HtmlDocument returnDocument = new HtmlDocument();
            while (!loaded && retryCount <= maxRetries )
            {
                try
                {
                    returnDocument = _htmlWeb.Load(url);
                    loaded = true;
                }
                catch (Exception ex)
                {
                    _log.Error("Failed to load the document", ex);
                    _log.DebugFormat("Will retry. {0}/{1}", retryCount, maxRetries);
                    retryCount++;
                }
            }
            return returnDocument;
        }
    }
}
