﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using VehicleStatsBL.Interface;

namespace VehicleStatsBL.Impl
{
    [Serializable]
    public class StatisticsFactory : IStatisticsFactory
    {
        public IStatistics GetStatistics(IEnumerable<IVehicle> sampleVehicles)
        {
            if (sampleVehicles == null || sampleVehicles.Count() == 0)
                return new NullStatistics();

            return new Statistics(sampleVehicles);
        }
    }
}
