﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Timers;

namespace VehicleStatsBL.Interface
{
    public interface IExtractionResults
    {
        List<IVehicle> Vehicles { get; }
        TimeSpan OperationDuration { get; }

        void Start();
        void Stop();

        IStatistics SampleStatistics { get; }
        IStatistics GetStatisticsByYearRange(int from, int to);
        IStatistics GetStatisticsByTitleCriteria(string searchString);

        int LowestYear {get ;}
        int HighestYear { get; }
    }

   
}