﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace VehicleStatsBL.Interface
{
    public interface IStatistics
    {
        double MeanPrice { get;   }
        double MedianPrice { get;  }
        double ModePrice { get;   }
        double StandardDeviation { get;   }
        int SampleSize { get; }
        double LowestPrice { get; }
        double HighestPrice { get; }

        IEnumerable<Tuple<int, double, int>> MeanPriceByYear { get; }
        IEnumerable<Tuple<int, double, int>> DepreciationByYear { get; }
        IEnumerable<Tuple<int, double>> DepreciationByYearCumulative { get; }
    }
}
